from selenium.webdriver.common.by import By
from selenium.webdriver.support.wait import WebDriverWait

from common.driver import get_app_driver
import time



class BasePage:

    driver = get_app_driver()

    def __int__(self, driver):
        self.driver = driver

    def wait(self, func):
        return WebDriverWait(self.driver,5).until(func)

    def find_element(self, by, value, need_wait=False):
        def f(driver):
            if driver.find_element(by,value).text:
                msg = driver.find_element(by,value).text
                if need_wait:
                    return msg
                else:
                    return True
            else:
                return True
        self.wait(f)
        return self.driver.find_element(by, value)



class LoginPage(BasePage):

    #time.sleep(0.5)
    btn_agree = (By.XPATH,'//*[@text="同意"]')
    #time.sleep(0.5)
    btn_know = (By.XPATH,'//*[@text="知道了"]')
    #time.sleep(0.5)
    btn_ok = (By.XPATH,'//*[@text="允许"]')
    #time.sleep(0.5)
    btn_not_login = (By.XPATH,'//*[@text="未登录"]')
    #time.sleep(0.5)
    btn_login = (By.XPATH,'//*[@text="登录"]')
    #time.sleep(0.5)
    btn_change_login = (By.XPATH,'//*[@text="账号密码登录"]')
    #time.sleep(0.5)
    btn_mobile = (By.XPATH,'//*[@text="手机号/邮箱账号"]')
    btn_password = (By.XPATH,'//*[@text="密码"]')
    btn_login_button = (By.XPATH,'//*[@text="登 录"]')
    #time.sleep(3)
    btn_personal = (By.ID,'com.ifeng.news2:id/txt_personal_page')
    def login(self,username,password):
        self.find_element(*self.btn_agree).click()
        self.find_element(*self.btn_know).click()
        self.find_element(*self.btn_ok).click()
        self.find_element(*self.btn_not_login).click()
        self.find_element(*self.btn_login).click()
        self.find_element(*self.btn_change_login).click()
        self.find_element(*self.btn_mobile).send_keys(username)
        self.find_element(*self.btn_password).send_keys(password)
        self.find_element(*self.btn_login_button).click()
        msg = self.find_element(*self.btn_personal).text
        print(msg)


